"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = falseOrOfType;
function falseOrOfType(type) {
  return function (props, propName, componentName) {
    var prop = props[propName];
    if (prop !== false || Object.prototype.toString.call(prop).slice(8, -1) === type) {
      return new Error("Warning: Failed prop type: " + componentName + " expect\n      " + propName + " to be a " + type + " or equal to false");
    }

    return null;
  };
}